#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <sys/stat.h>

#include "asim/rrr/service_ids.h"

#include "asim/provides/connected_application.h"



using namespace std;

// ===== service instantiation =====
AUDIOCORERRR_SERVER_CLASS AUDIOCORERRR_SERVER_CLASS::instance;

// constructor
AUDIOCORERRR_SERVER_CLASS::AUDIOCORERRR_SERVER_CLASS() :
  serverStub(new AUDIOCORERRR_SERVER_STUB_CLASS(this))
{
    // instantiate stub
    printf("AUDIOCORERRR init called\n");
    outputFile = NULL;
    memory = NULL;
    fflush(stdout);
}

// destructor
AUDIOCORERRR_SERVER_CLASS::~AUDIOCORERRR_SERVER_CLASS()
{
    Cleanup();
}

// init
void
AUDIOCORERRR_SERVER_CLASS::Init(PLATFORMS_MODULE p)
{
    parent = p;
}

// uninit
void
AUDIOCORERRR_SERVER_CLASS::Uninit()
{
    Cleanup();
}

// cleanup
void
AUDIOCORERRR_SERVER_CLASS::Cleanup()
{
    delete serverStub;
}


//
// RRR service methods
//

UINT32
AUDIOCORERRR_SERVER_CLASS::MemoryRequestLoad (UINT32 address)
{
  UINT32 returnVal;
  
  if(memory == NULL) {
    memory = new FUNCP_SIMULATED_MEMORY_CLASS();
  }

 
  memory->Read(0,(UINT64) address, sizeof(UINT32), &returnVal); 
  return returnVal;
}

void
AUDIOCORERRR_SERVER_CLASS::MemoryRequestStore (UINT32 address, UINT32 data)
{
  if(memory == NULL) {
    memory = new FUNCP_SIMULATED_MEMORY_CLASS();
  }

  memory->Write(0,(UINT64) address, sizeof(UINT32), &data); 

void

AUDIOCORERRR_SERVER_CLASS::SendProcessedStream(UINT16 control, UINT16 data)
{

  AudioProcessorControl audioProcessorControl = (AudioProcessorControl) control;
  switch(control) {
    case EndOfFile:
      if(outputFile != NULL) {
        fflush(outputFile);
        fclose(outputFile);
        outputFile = NULL;
      } else {
        outputFile = fopen("out_hw.pcm","w");
        assert(outputFile);
        fflush(outputFile);
        fclose(outputFile);
      }

      // Long term this should be in the data portion.  But until I have code running, keep it here.
      CONNECTED_APPLICATION_CLASS::EndSimulation(); 
    break;

    case Data:
      if(outputFile == NULL) {
        outputFile = fopen("out_hw.pcm","w");
        assert(outputFile);
      }

      CONNECTED_APPLICATION_CLASS::UpdateSemaphore();  
      fwrite(&data, 2,1 , outputFile);
    break;
  }
}
